RealisticFieldFlooding = {}


function RealisticFieldFlooding:loadMap()
    RealisticFieldFlooding.WaterSupplierRange = 10;
end

function RealisticFieldFlooding:update()
    if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
        if RealisticFieldFlooding.lastUpdateTime == nil or RealisticFieldFlooding.lastUpdateTime + 500 <= g_time then
            RealisticFieldFlooding:UpdateFields();
            RealisticFieldFlooding.lastUpdateTime = g_time
        end
    end
end

function RealisticFieldFlooding:UpdateFields()
    local Placeables = g_currentMission.placeableSystem.placeables
    for i = #Placeables, 1, -1 do
        local Iplaceable = Placeables[i]   
        if Iplaceable.spec_riceField then
            local Fields = Iplaceable:getFields()
            for z = #Fields, 1, -1 do
                local IField = Fields[z]
                RealisticFieldFlooding:UpdateField(Iplaceable, IField, z)
            end
        end
    end
end

function RealisticFieldFlooding:UpdateField(RicePlaceable, RiceField, FieldIndex)
    if RiceField.isFilling then
        local WasWaterSubtracted = RealisticFieldFlooding:SubtractWater(RiceField.pumpNode, RealisticFieldFlooding.WaterSupplierRange, RicePlaceable:getArea(FieldIndex));
        if not WasWaterSubtracted then
            RicePlaceable:setWaterHeightTarget(FieldIndex, RicePlaceable:getWaterHeight(FieldIndex))
        end
    end
end

function RealisticFieldFlooding:SubtractWater(pumpNode, WaterSupplierRange, Area)
    local VehicleInstance, fillUnitIndex = RealisticFieldFlooding:GetWaterSupplierRange(pumpNode, WaterSupplierRange);
    
    if VehicleInstance == nil then
        return false;
    end

    if VehicleInstance:getFillUnitFillLevel(fillUnitIndex) < 1 then
        return false;
    end

    local Usage = ((Area*0.5) * g_currentMission:getEffectiveTimeScale()) * 0.0001;
    VehicleInstance:addFillUnitFillLevel(VehicleInstance:getOwnerFarmId(), fillUnitIndex, -Usage, FillType.WATER,ToolType.UNDEFINED,nil)

    return true;
end

function RealisticFieldFlooding:GetWaterSupplierRange(TargetNode, Range)
    for VehicleIndex, VehicleInstance in ipairs(g_currentMission.vehicleSystem.vehicles) do
        local VehicleInstance = g_currentMission.vehicleSystem.vehicles[VehicleIndex]
        if VehicleInstance ~= nil and VehicleInstance.getFillUnits ~= nil then
            for fillUnitIndex, fillUnit in ipairs(VehicleInstance:getFillUnits()) do
                if fillUnitIndex ~= nil then
                    local vehicleFillType = VehicleInstance:getFillUnitFillType(fillUnitIndex)
                    local vehicleFillLevel = VehicleInstance:getFillUnitFillLevel(fillUnitIndex)
                    if vehicleFillType == FillType.WATER and vehicleFillLevel > 0 then
                        local Distance = calcDistanceFrom(TargetNode, VehicleInstance.rootNode)
                        if Distance <= Range then
                            return VehicleInstance, fillUnitIndex
                        end
                    end
                end
            end
        end
    end

    return nil, nil
end

addModEventListener(RealisticFieldFlooding)

--ConstructionScreen.registerMenuActionEvents = Utils.appendedFunction(ConstructionScreen.registerMenuActionEvents, ExtendedTerraformingRegisterMenuActionEvents);
