RealisticFieldFloodingGui = {}

function RealisticFieldFloodingGui:convertStringToNumber(input)
    -- Remove non-numeric characters (except dot for decimals)
    local numericPart = input:match("[%d%.]+")
    -- Convert the extracted part to a number
    return tonumber(numericPart)
end

function RealisticFieldFloodingGui:onRiceFieldStatusResult()

    for Index, Field in ipairs(self.riceFieldPlaceable:getFields()) do
        if Index == self.riceFieldIndex then

            local VehicleInstance, fillUnitIndex = RealisticFieldFlooding:GetWaterSupplierRange(Field.pumpNode, RealisticFieldFlooding.WaterSupplierRange);
    
            if Field.isEmptying == false and VehicleInstance == nil then
                self.warning:setText(g_i18n:getText("text_NoSupply"))
                self.warning:setVisible(true)
                self.buttonFill:setDisabled(true)
                return;
            end

            local Percentage = RealisticFieldFloodingGui:convertStringToNumber(self.textWaterLevel.text)
            
            if Field.isFilling == false and Field.isEmptying == false and self.textCropType.text == "-" and Percentage < 65 and self.riceFieldPlaceable:getWaterHeight(Index) > 0 then
                self.warning:setText(g_i18n:getText("ui_riceFieldWarningWaterLevelTooLow"))
                self.warning:setVisible(true)
                self.buttonFill:setDisabled(false)
                self.targetWaterPercentage = 0,65
            end

        end
    end
end

RiceFieldDialog.onRiceFieldStatusResult = Utils.appendedFunction(RiceFieldDialog.onRiceFieldStatusResult, RealisticFieldFloodingGui.onRiceFieldStatusResult);


function RealisticFieldFloodingGui:DialogOpen()
    --RealisticFieldFloodingGui.ActiveGui = self;
end

function RealisticFieldFloodingGui:DialogClose()
    --RealisticFieldFloodingGui.ActiveGui = nil;
end

function RealisticFieldFloodingGui:loadMap()
    --g_gui.guis.RiceFieldDialog.onOpenCallback = Utils.appendedFunction(g_gui.guis.RiceFieldDialog.onOpenCallback, RealisticFieldFloodingGui.DialogOpen);
    --g_gui.guis.RiceFieldDialog.onCloseCallback = Utils.appendedFunction(g_gui.guis.RiceFieldDialog.onCloseCallback, RealisticFieldFloodingGui.DialogClose);
end

addModEventListener(RealisticFieldFloodingGui)